#include <iostream>
#include <fstream>

#include <cctype>  // wegen isalpha
#include <string>
#include <set>
#include <map>
#include <iomanip> // wegen setw
#include "CppLine.h"

using namespace std;

typedef map<string, int, less<string> > T_WordCntMap;
typedef set<string, less<string> > T_CppKeyWords;

const int MAX_LINE_LENGTH = 200;

void FillKeyWordTable
(
T_CppKeyWords & arc_keyWordTable
)
{
   arc_keyWordTable.insert("void");
   arc_keyWordTable.insert("int");
   arc_keyWordTable.insert("float");
   arc_keyWordTable.insert("char");
   arc_keyWordTable.insert("typedef");
   arc_keyWordTable.insert("if");
   arc_keyWordTable.insert("for");
   arc_keyWordTable.insert("while");
   arc_keyWordTable.insert("do");
   arc_keyWordTable.insert("return");
   arc_keyWordTable.insert("sizeof");
   arc_keyWordTable.insert("switch");

   arc_keyWordTable.insert("include");
   arc_keyWordTable.insert("using");
   arc_keyWordTable.insert("namespace");
}


int main()
{
   T_WordCntMap wordCntMap;
   T_CppKeyWords keyWordTable;

   ifstream datei(".\\CppLine.cxx", ios::in);

   if (!datei.good())
   {
      cerr << "datei konnte nicht geoeffnet werden." << endl;
      exit(-1);
   }

   FillKeyWordTable(keyWordTable);

   // Alle Vorkommen mit 0 initialisieren
   for (auto siter : keyWordTable)
   {
      wordCntMap[siter] = 0;
   }
   char sourceLine[MAX_LINE_LENGTH];
   datei.getline(sourceLine, MAX_LINE_LENGTH);

   while (datei.good())
   {
      string word;
      // Wort fuer Wort aus der Zeile extrahieren
      CppLine cppline(sourceLine);
      while ((word = cppline.GetNxtWord(word)) != "")
      {
         // gucken, ob es ein Schluesselwort ist.
         if (keyWordTable.find(word) != keyWordTable.end())
         {
            ++wordCntMap[word];
         }
      }//while ( ( word = cppline.GetNxtWord(word)) != "")

      // naechste Codezeile einlesen    
      datei.getline(sourceLine, MAX_LINE_LENGTH);

   } // while (datei. good()

   // auto& anstatt auto, damit nur Referenzen und
   // keine Kopien der Mapeintraege angelegt werden
   for (auto& iter : wordCntMap )
   {
      cout << setw(10) << iter.first << " : "
         << setw(5) << iter.second << endl;
   }

   return 0;
}

